#include <stdio.h>
#include <string.h>
#include "DHT.h"

#define DHTPIN 2     // Digital pin connected to the DHT sensor

#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321

DHT dht(DHTPIN, DHTTYPE);

String st = "";

int nmea0183_checksum(char *nmea_data)
{
  int crc = 0;
  int i;

  // ignore the first $ sign,  no checksum in sentence
  for (i = 1; i < strlen(nmea_data); i ++) { // removed the - 3 because no cksum is present
    crc ^= nmea_data[i];
  }
  return crc;
}

void setup() {
  SerialUSB.begin(115200);
  dht.begin();
}

void loop() {
  // Wait a few seconds between measurements.
  delay(2000);

  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h = dht.readHumidity();
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();
  // Check if any reads failed and exit early (to try again).
  if (isnan(h) || isnan(t))  {
    //Serial.println(F("Failed to read from DHT sensor!"));
    delay(20);
    return;
  }

  // NMEA output in openvario format
  st = "$POV,T," + String(t, 1) ;
  st = st + "*" + String(nmea0183_checksum(st.c_str()), HEX);
  st.toUpperCase();
  SerialUSB.println(st);

  st = "$POV,H," + String(h, 1) ;
  st = st + "*" + String(nmea0183_checksum(st.c_str()), HEX);
  st.toUpperCase();
  SerialUSB.println(st);
}
